package cn.rankin.cmsweb.controller.user;

import cn.rankin.cmsweb.service.user.UserRecommendService;
import cn.rankin.cmsweb.service.user.UserTagServiceInterface;
import cn.rankin.common.utils.api.model.APICode;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.vo.UserRecommendVo;
import cn.rankin.data.api.user.entity.UserRecommend;
import cn.rankin.data.api.user.entity.UserTag;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/user")
public class UserController {

    @Autowired
    private UserRecommendService userRecommendService;

    @Autowired
    private UserTagServiceInterface userTagService;

    // 用户推荐位设置
    @RequestMapping(value = "/userRecommend/uid/{uid}", method = RequestMethod.GET)
    public APIResult<List<UserRecommendVo>> getUserRecommend(@PathVariable("uid") String uid) {
        if (StringUtils.isEmpty(uid)) {
            return APIResult.error(APICode.PARAMETER_ERROR);
        }
        List<UserRecommend> userRecommendList = userRecommendService.get(uid);
        return APIResult.ok(userRecommendList);
    }

    @RequestMapping(value = "/userRecommend/uid/{uid}", method = RequestMethod.PUT)
    public APIResult<List<UserRecommendVo>> updateUserRecommend(@PathVariable("uid") String uid, @RequestBody List<String> productIdList) {
        if (StringUtils.isEmpty(uid) || CollectionUtils.isEmpty(productIdList)) {
            return APIResult.error(APICode.PARAMETER_ERROR);
        }

        List<UserRecommend> userRecommendList = userRecommendService.put(uid, productIdList);
        return APIResult.ok(userRecommendList);
    }

    //用户标签配置
    @RequestMapping(value = "/userTag/uid/{uid}", method = RequestMethod.GET)
    public APIResult<UserTag> getUserTagsByUid(@PathVariable("uid") String uid) {
        List<UserTag> userTags = userTagService.findUserTagByUid(uid);
        if (userTags != null) {
//            merchantInfoSetService.setMerchantInfo(apiResult.getData());

            userTags.forEach(userTag -> {
                userTag.getRelationList();





            });


            /*public List<ItemVo> findItemByPids(List<String> productIdList, String merchantId) {
                return productClient.findItemByPids(productIdList,merchantId);
            }*/
            return APIResult.ok(userTags);
        }else{
            return APIResult.error(APICode.NOT_EXISTS);
        }
    }

}
