package cn.rankin.userservice.controller;

import cn.rankin.data.api.user.entity.UserRecommend;
import cn.rankin.userservice.service.UserRecommendService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/userRecommend")
public class UserRecommendController {

    @Autowired
    private UserRecommendService userRecommendService;

    @RequestMapping(value = "/uid",method = RequestMethod.GET)
    public List<UserRecommend> get(@RequestParam("uid") String uid) {
        List<UserRecommend> recommendList = userRecommendService.get(uid);
        return recommendList;
    }

    @RequestMapping(value = "/uid",method = RequestMethod.PUT)
    public List<UserRecommend> put(@RequestParam("uid") String uid, @RequestBody List<String> productIdList) {
        List<UserRecommend> recommendList = userRecommendService.put(uid, productIdList);
        return recommendList;
    }

    @RequestMapping(value = "/courses/uid/{uid}", method = RequestMethod.GET)
    public List<UserRecommend> getUserRecommendCourses(@RequestParam("uid") String uid) {
        List<UserRecommend> recommendList = userRecommendService.getUserRecommendCourses(uid);
        return recommendList;
    }
}
